//---------------------------------------------------------------------------

#ifndef backup_srcH
#define backup_srcH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "Cabinet.hpp"
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <jpeg.hpp>
#include "CABArchiver.h"
#include <Dialogs.hpp>
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------
class TBackup : public TForm
{
__published:	// IDE-managed Components
        TBevel *Bevel1;
        TImage *Image1;
        TLabel *Label1;
        TBevel *Bevel2;
        TCABArchiver *CABARchiver1;
        TImage *iswitch;
        TSpeedButton *SpeedButton1;
        TSpeedButton *SpeedButton2;
        TSpeedButton *SpeedButton3;
        TLabel *iSalvar1;
        TLabel *iSalvar2;
        TLabel *iSalvar3;
        TEdit *FCab;
        TSpeedButton *BuscaDestino;
        TSaveDialog *SaveDialog1;
        TLabel *Panel1;
        TProgressBar *Gauge1;
        TProgressBar *Gauge2;
        TLabel *Panel2;
        TOpenDialog *OpenDialog1;
        void __fastcall SpeedButton1Click(TObject *Sender);
        void __fastcall SpeedButton2Click(TObject *Sender);
        void __fastcall SpeedButton3Click(TObject *Sender);
        void __fastcall BuscaDestinoClick(TObject *Sender);
        void __fastcall CABARchiver1CABMessage(TObject *sender, int position,
          int total, AnsiString message, TStat mode, AnsiString Lapse);
        void __fastcall Image1MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall Image1MouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
private:	// User declarations
        int StartX, StartY;
public:		// User declarations
        __fastcall TBackup(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TBackup *Backup;
//---------------------------------------------------------------------------
#endif
